﻿using System;
using Microsoft.Scripting;
using Microsoft.Scripting.Hosting;

namespace A_Hosting_DLR
{
    class Program
    {
        static void Main(string[] args)
        {
            A();
            Console.ReadLine();
        }

        private static void A()
        {
            string rubyCode = "puts \"Hello World\"";


            ScriptRuntime runtime = ScriptRuntime.Create();
            ScriptEngine engine = runtime.GetEngine("IronRuby");
            ScriptScope scope = engine.CreateScope();
            scope.Execute(rubyCode);
        }

        private static void B()
        {
            DLRHost dlr = new DLRHost();
            dlr.ExecuteRubyCode("$a = 1");
            dlr.ExecuteRubyCode("puts $a");
        }

        private static void C()
        {
            DLRHost dlr = new DLRHost();
            dlr.ExecuteRubyCode("def Save(val) " +
                                    "puts \"We are now saving the value: #{val}\" " +
                                "end " + Environment.NewLine +
                                "puts \"Save method created\"");

            Console.Write("Enter a value to save: ");

            string print = Console.ReadLine();

            dlr.ExecuteRubyCode("Save(" + print + ")");
        }
    }

    internal class DLRHost
    {
        private ScriptEngine engine;
        private ScriptScope scope;

        public DLRHost()
        {
            ScriptRuntime runtime = ScriptRuntime.Create();
            engine = runtime.GetEngine("rb");
            scope = engine.CreateScope();
        }

        public void ExecuteRubyCode(string code)
        {
            ScriptSource source = engine.CreateScriptSourceFromString(code, SourceCodeKind.Expression);

            source.Execute(scope);
        }
    }
}
