﻿using System;
using System.Collections.Generic;
using Microsoft.Scripting;
using Microsoft.Scripting.Hosting;
using Ruby;
using Ruby.Runtime;

namespace B_Monkey_Patching
{
    class Program
    {
        static void Main(string[] args)
        {
            DLRHost dlr = new DLRHost();
            Console.Write("IronRuby code:  ");
            string line = Console.ReadLine();

            while (line != "quit")
            {
                dlr.ExecuteRubyCode(line);
                Console.Write("IronRuby code:  ");
                line = Console.ReadLine();
            }
        }
    }

    internal class DLRHost
    {
        private ScriptEngine engine;
        private ScriptScope scope;
        List<string> list;


        public DLRHost()
        {
            ScriptRuntime runtime = IronRuby.CreateRuntime();
            engine = IronRuby.GetEngine(runtime);
            RubyExecutionContext ctx = IronRuby.GetExecutionContext(engine);

            list = new List<string>();
            ctx.DefineGlobalVariable("customers", list);

            string startingBlock = @"require 'mscorlib' 
                                    def $customers.method_missing(methodname, *args)
                                        print ""Ruby: $customers."", methodname, "" called\n""
                                        $customers.add(methodname.to_s)
                                    end
                                    ";

            scope = engine.CreateScope();
            scope.Execute(startingBlock);
        }

        public void ExecuteRubyCode(string code)
        {
            scope.Execute(code);

            Console.WriteLine("C#: " + list.Count);
        }
    }
}
